# Service Object
inspired by [active_service](https://github.com/chloerei/active_service) .

Service Object is a service object abstraction which implement service-object-pattern introduced by http://brewhouse.io/blog/2014/04/30/gourmet-service-objects.html .

It is lightweight and fast, almost no performance loss. It's testing friendly, works great with all test framework like minitest/rspec.

It also add a service layer in Rails, you can use Rails generator to generate service file like controller and model.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'service-object'
```

And then execute:

    $ bundle

## Usage


Declare a service like so:

```ruby
class AcceptInvite

  def self.call(invite, user)
    invite.accept!(user)
    UserMailer.invite_accepted(invite).deliver
  end

end
```



## Rails generator

If you are using Rails:

```bash
rails g service AcceptInvite
```

It will create template service files in app/services and test/services.

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release` to create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

1. Fork it ( https://github.com/leihb/service_object )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
